<template>
<div>
    <el-col :span="11" >
		<h4 style="margin: 1.5rem 0rem 0.5rem 0rem"> NOTA: </h4>
		
		<div class="box-buttons">
			<button @click="textStyle('textBold')" class="btn-style-note">
				<!-- <i class="icon-bold i-style-note"></i> -->
				B
			</button>
			<button @click="textStyle('textItalic')" class="btn-style-note">
				<!-- <i class="icon-italic i-style-note"></i> -->
				K
			</button>
			<button @click="textStyle('textUnderline')" class="btn-style-note">
				<i class="icon-underline i-style-note"></i>
			</button>		
			
			<el-dropdown class="space-special-botton">
				<span class="el-dropdown-link  special-botton-style">
					<i class="icon-transform-letter"></i>
				</span>
				<el-dropdown-menu slot="dropdown">
					<el-dropdown-item @click.native="toUpperCase">May.</el-dropdown-item>
					<el-dropdown-item @click.native="toLowerCase">Min.</el-dropdown-item>
				</el-dropdown-menu>
			</el-dropdown>

			<el-dropdown class="space-special-botton">
				<span class="el-dropdown-link  special-botton-style" style="text-align: center">
					<i class="icon-color-text"></i>
				</span>
				<el-dropdown-menu slot="dropdown">
					<el-dropdown-item @click.native="isColorRed">
						<div class="btn-color-text bg-redColor"></div>
					</el-dropdown-item>
					<el-dropdown-item @click.native="isColorBlue">
						<div class="btn-color-text bg-blueColor"></div>
					</el-dropdown-item>
					<el-dropdown-item @click.native="isColorBlack">
						<div class="btn-color-text bg-blackColor"></div>
					</el-dropdown-item>
				</el-dropdown-menu>
			</el-dropdown>
		</div>
		<el-input 
			:value="value"
			@input="updateTextArea()"
			style="margin: 0 0 2.2rem 0"
			type="textarea"
			:autosize="{ minRows: 2, maxRows: 4}"
			placeholder="Añadir una nota.."
			ref="textArea">
			<!-- placeholder="Maximo 30 carácteres..."
			maxlength="30" -->
		</el-input>
	</el-col>
</div>
</template>

<script>
    export default {
		inheritAttrs: false,
		name: 'NoteWritter',
		props: [
			'value'
		],
		data() {
			return {
				text: ''
			}
		},
		methods: {
			elemInput() {
				return this.$refs.textArea.$el.children[0]
			},
			updateTextArea() {
				this.$emit('input', this.$refs.textArea.$el.children[0].value)
			},
			textStyle(val) {
				// console.log(val, 'oooo')
				const elem = this.$refs.textArea.$el.children[0]
				elem.classList.toggle(val)
			},
			toUpperCase() {
				const elem = this.elemInput()
				elem.classList.add("upperCase")
				elem.classList.remove("lowerCase")
			},
			toLowerCase() {
				const elem = this.elemInput()
				elem.classList.add("lowerCase")
				elem.classList.remove("upperCase")
			},
			isColorRed() {
				const elem = this.elemInput()
				elem.classList.add("redColor")
				elem.classList.remove("blueColor")
			},
			isColorBlue() {
				const elem = this.elemInput()
				elem.classList.add("blueColor")
				elem.classList.remove("redColor")
			},
			isColorBlack() {
				const elem = this.elemInput()
				elem.classList.add("blackColor")
				elem.classList.remove("redColor")
				elem.classList.remove("blueColor")
			},
			resetNote() {
				const elem = this.elemInput()
				elem.className = 'el-textarea__inner'
			},
			addClassTextArea() {
				if(this.$refs.textArea) {
					let elem = this.elemInput()
					elem.classList.add("textarea-style")
				}
			}
		},
		mounted() {
			this.$nextTick(() => {
				this.addClassTextArea()
			})
		},
    }
</script>

<style>
	.textBold {
		font-weight: bold;
	}
	.textUnderline {
		text-decoration-line: underline;
	}
	.textItalic {
		font-style: italic;
	}
	.upperCase {
		text-transform: uppercase;
	}
	.lowerCase {
		text-transform: lowercase;
	}
	.redColor {
		color: red !important;
	}
	.blueColor {
		color: blue !important;
	}
	.btn-style-note {
		width: 20px;
		height: 20px;
		border-radius: 2px;
    	border: 1px solid #A7A7A7;
		margin: 0 2.5px;
		color: #A7A7A7;
		background-color: #FFFF;
	}
	.i-style-note {
		top: 1px;
    	position: relative;
	}

	.space-special-botton {
		margin: 0 2.5px;
	}
	.special-botton-style {
		display: inline-block;
		height: 19px !important;
		border: 1px solid #A7A7A7;
		color: #A7A7A7;
		border-radius: 2px;
		width: 20px;
	}
	.box-buttons {
		border: 1px solid #A7A7A7;
        padding: 3px;
        width: 60%;
        border-top-left-radius: 4px;
        border-top-right-radius: 4px;
        border-bottom: none;
	}
	.textarea-style {
		border: 1px solid#A7A7A7 !important;
		border-top-left-radius: 0px !important;
		height: 65px !important;
		min-height: 65px !important;
	}
</style>